// Licensed Materials - Property of IBM
// 5725-C95
// Copyright IBM Corporation 2009, 2012. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

var wshShell = WScript.createobject("WScript.Shell");
var fileObject = WScript.createobject("Scripting.FileSystemObject");
var cmd = "%windir%\\system32\\cmd.exe";

function getProductProperty(propertyName)
{
    var forReading = 1;
    var tristateUseDefault = -2;
    
    var f = fileObject.GetFile(${WBIROOT} + "\\util\\bpm.shortcuts.nls\\script\\count.properties");
    var ts = f.OpenAsTextStream(forReading, tristateUseDefault);
    
    var propertyValue = "";
    while (!ts.AtEndOfStream)
    {
        var lineText = ts.ReadLine();
        if ( lineText.indexOf(propertyName) >= 0)
        {
            propertyValue = lineText.substr(lineText.lastIndexOf("=") +  1);
            break;
        }
    }
    ts.Close();
    
    return propertyValue;
}

var productLabel = getProductProperty("com.ibm");

var startMenuLocation = wshShell.SpecialFolders("Programs");
var IBM = startMenuLocation + "\\IBM";
var product = IBM + "\\" + productLabel;
var profiles = product + "\\${PROFILESDIR}";
var profile = profiles + "\\${PROFILENAME}";

if (!(fileObject.FolderExists(IBM)))
      fileObject.CreateFolder(IBM);

if (!(fileObject.FolderExists(product)))
      fileObject.CreateFolder(product);

if (!(fileObject.FolderExists(profiles)))
      fileObject.CreateFolder(profiles);

if (!(fileObject.FolderExists(profile)))
      fileObject.CreateFolder(profile);

var objShellLinkAdministrativeConsole = wshShell.CreateShortcut(profile + "\\${ADMINCONSOLE}.lnk");      
var objShellLinkSamplesGallery = wshShell.CreateShortcut(profile + "\\${SAMPLE}.lnk");      
var objShellLinkFirstSteps = wshShell.CreateShortcut(profile + "\\${FIRSTSTEPS}.lnk");      
var objShellLinkPerformanceAdminConsole = wshShell.CreateShortcut(profile + "\\${PERCONSOLE}.lnk");
var objShellLinkProcessAdminConsole = wshShell.CreateShortcut(profile + "\\${PACONSOLE}.lnk");        
var objShellLinkProcessCenterConsole = wshShell.CreateShortcut(profile + "\\${PCCONSOLE}.lnk");  
var objShellLinkProcessPortal = wshShell.CreateShortcut(profile + "\\${PORTAL}.lnk");
var objShellLinkStartServer = wshShell.CreateShortcut(profile + "\\${STARTSERVER}.lnk");
var objShellLinkStopServer = wshShell.CreateShortcut(profile + "\\${STOPSERVER}.lnk");

//1: Activates and displays a window. If the window is minimized or maximized, the system restores it to its original size and position. 
//3: Activates the window and displays it as a maximized window.  
//7: Minimizes the window and activates the next top-level window. 
objShellLinkAdministrativeConsole.WindowStyle = 1;
objShellLinkSamplesGallery.WindowStyle = 1;
objShellLinkFirstSteps.WindowStyle = 7;
objShellLinkProcessCenterConsole.WindowStyle = 1;
objShellLinkStartServer.WindowStyle = 1;
objShellLinkStopServer.WindowStyle = 1;

var isPC = false;
var appFolder = fileObject.getFolder(${PROFILEROOT} + "\\config\\cells\\${CELLNAME}\\applications");
var fe = new Enumerator(appFolder.SubFolders);
for (; !fe.atEnd();fe.moveNext()){
  var subFolderName = fe.item().Name;
  if (subFolderName.indexOf("IBM_BPM_Repository_")==0) {
      isPC = true;
      break;
  }
}

if ( (fileObject.FolderExists(${PROFILEROOT} + "\\config\\cells\\${CELLNAME}\\applications\\isclite.ear") ) )
{
objShellLinkAdministrativeConsole.IconLocation = ${WBIROOT} + "\\bin\\icons\\console.ico";
	objShellLinkAdministrativeConsole.TargetPath = cmd;
objShellLinkAdministrativeConsole.Arguments = "/c start /b http://localhost:"+ ${CONSOLEPORT} +"/ibm/console";
objShellLinkAdministrativeConsole.Description = "${ADMINCONSOLE}";
objShellLinkAdministrativeConsole.Save(); //commit change
}

if (isPC) {
    // Business Performance Admin Console
    objShellLinkPerformanceAdminConsole.IconLocation = ${WBIROOT} + "\\bin\\icons\\console.ico";
    objShellLinkPerformanceAdminConsole.TargetPath = cmd;
    objShellLinkPerformanceAdminConsole.Arguments = "/c start /b http://localhost:"+ ${DEFAULTPORT} +"/PerformanceAdmin";
    objShellLinkPerformanceAdminConsole.Description = "${PERCONSOLE}";
    objShellLinkPerformanceAdminConsole.Save();  //commit change
}


if ( (fileObject.FolderExists(${PROFILEROOT} + "\\installedApps\\${CELLNAME}\\SamplesGallery.ear") ) )
{
      objShellLinkSamplesGallery.IconLocation = ${WBIROOT} + "\\bin\\icons\\samples.ico";
      objShellLinkSamplesGallery.TargetPath = cmd;
      objShellLinkSamplesGallery.Arguments = "/c start /b http://localhost:" + ${SAMPLEPORT} + "/WSsamples";
      objShellLinkSamplesGallery.Description = "${SAMPLE}";
      objShellLinkSamplesGallery.Save(); //commit change
}      

objShellLinkFirstSteps.IconLocation = ${WBIROOT} + "\\bin\\icons\\firststeps.ico";
objShellLinkFirstSteps.TargetPath = ${PROFILEROOT} + "\\firststeps\\bpmStd\\firststeps.bat";
objShellLinkFirstSteps.WorkingDirectory = ${PROFILEROOT} + "\\firststeps\\bpmStd";
objShellLinkFirstSteps.Description = "${FIRSTSTEPS}";
objShellLinkFirstSteps.Save(); //commit change

// Process Admin Console
objShellLinkProcessAdminConsole.IconLocation = ${WBIROOT} + "\\bin\\icons\\console.ico";
objShellLinkProcessAdminConsole.TargetPath = cmd;
objShellLinkProcessAdminConsole.Arguments = "/c start /b http://localhost:"+ ${DEFAULTPORT} +"/ProcessAdmin";
objShellLinkProcessAdminConsole.Description = "${PACONSOLE}";
objShellLinkProcessAdminConsole.Save();  //commit change

if (isPC) {
    // Process Center Console
    objShellLinkProcessCenterConsole.IconLocation = ${WBIROOT} + "\\bin\\icons\\console.ico";
    objShellLinkProcessCenterConsole.TargetPath = cmd;
    objShellLinkProcessCenterConsole.Arguments = "/c start /b http://localhost:"+ ${DEFAULTPORT} +"/ProcessCenter";
    objShellLinkProcessCenterConsole.Description = "${PCCONSOLE}";
    objShellLinkProcessCenterConsole.Save();  //commit change
}

// Process Portal
objShellLinkProcessPortal.IconLocation = ${WBIROOT} + "\\bin\\icons\\console.ico";
objShellLinkProcessPortal.TargetPath = cmd;
objShellLinkProcessPortal.Arguments = "/c start /b http://localhost:"+ ${DEFAULTPORT} +"/portal";
objShellLinkProcessPortal.Description = "${PORTAL}";
objShellLinkProcessPortal.Save();  //commit change 

objShellLinkStartServer.IconLocation = ${WBIROOT} + "\\bin\\icons\\start_server.ico";
objShellLinkStartServer.TargetPath = ${PROFILEROOT} + "\\bin\\startserver.bat";
objShellLinkStartServer.Arguments = "${SERVERNAME}";
objShellLinkStartServer.WorkingDirectory = ${PROFILEROOT} + "\\bin";
objShellLinkStartServer.Description = "${STARTSERVER}";
objShellLinkStartServer.Save(); //commit change

objShellLinkStopServer.IconLocation = ${WBIROOT} + "\\bin\\icons\\server_stopped.ico";
objShellLinkStopServer.TargetPath = ${PROFILEROOT} + "\\bin\\stopserver.bat";
objShellLinkStopServer.Arguments = "${SERVERNAME}";
objShellLinkStopServer.WorkingDirectory = ${PROFILEROOT} + "\\bin";
objShellLinkStopServer.Description = "${STOPSERVER}";
objShellLinkStopServer.Save(); //commit change
